//+------------------------------------------------------------------+
//|                                                         orob.mq4 |
//|                                     Copyright  2010, ENSED Team |
//|                                             http://www.ensed.org |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, ENSED Team"
#property link      "http://www.ensed.org"
extern double Start_Lot=0.1; // 
extern double Lot_K=0.1; //   
extern int Delta = 50;
extern int Count=5; // "" 
extern int Magic_Number = 1234;
extern int TP=50; // Take Profit
extern int Slipage=10; //   
extern bool Sound=false; ///    
extern int Test_First_Order = 0; //0 -    , 1 - 
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   GlobalVariableDel("last_open"+Symbol()+Period());
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   GlobalVariableDel("last_open"+Symbol()+Period());
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

double sl(int sl_value, int mode, string symb="NONE", double price=0.0) { //  Stop Loss   
  //mode=0 -> 
  //mode=1 ->   
  if(symb=="NONE") symb=Symbol();
  if(price==0.0) {
    if(mode==0) price=MarketInfo(symb,MODE_ASK);
    if(mode==1) price=MarketInfo(symb,MODE_BID);
  }
  //Comment(mode," ",price," ",sl_value);
  if(sl_value<=0) return(0);
  if(mode==0 || mode==2 || mode==4)     return(price-sl_value*MarketInfo(symb,MODE_POINT)); // 
  if(mode==1 || mode==3 || mode==5)     return(price+sl_value*MarketInfo(symb,MODE_POINT)); // 
} //end sl(int sl_value, int mode)

double tp(int tp_value, int mode, string symb="NONE", double price=0.0) { //  Take Profit   
  //mode=0 -> 
  //mode=1 -> 
  if(symb=="NONE") symb=Symbol();
  if(price==0.0) {
    if(mode==0) price=MarketInfo(symb,MODE_ASK);
    if(mode==1) price=MarketInfo(symb,MODE_BID);
  }
  if(tp_value<=0) return(0);
  if(mode==0 || mode==2 || mode==4)     return(price+tp_value*MarketInfo(symb,MODE_POINT)); // 
  if(mode==1 || mode==3 || mode==5)     return(price-tp_value*MarketInfo(symb,MODE_POINT)); // 
} //end tp(int tp_value, int mode)



void check_orders() {
  int i = 0, k=0;
  double lot=0.0, lot_1=0.0;
  double price_1=0.0, price_2=0.0;
  for (i=OrdersTotal()-1; i>=0; i--) {
    if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
      price_1=NormalizeDouble(OrderTakeProfit(),Digits);
      price_2=NormalizeDouble(OrderStopLoss(),Digits);
      lot_1=OrderLots();
      RefreshRates();
    if(OrderType()==0) {     
      if(!find_orders(5,Magic_Number,price_2)) {
        lot=OrderLots()+Lot_K;
        open_positions(Magic_Number, 5, lot, price_2, OrderSymbol(),Delta,TP);
        for(k=0; k<Count-1; k++) {
          if(!find_orders(4, Magic_Number, price_1+(Delta*k)*MarketInfo(OrderSymbol(),MODE_POINT)+MarketInfo(Symbol(),MODE_SPREAD)*MarketInfo(Symbol(),MODE_POINT)))
            open_positions(Magic_Number, 4, Start_Lot, price_1+(Delta*k)*MarketInfo(OrderSymbol(),MODE_POINT)+MarketInfo(Symbol(),MODE_SPREAD)*MarketInfo(Symbol(),MODE_POINT), OrderSymbol(),Delta,Delta);
        }
      }
    }
    if(OrderType()==1) {     
      if(!find_orders(4,Magic_Number,price_2)) {
        lot=OrderLots()+Lot_K;
        open_positions(Magic_Number, 4, lot, price_2, OrderSymbol(),Delta,TP);
        for(k=0; k<Count-1; k++) {
          if(!find_orders(5, Magic_Number, price_1-(Delta*k)*MarketInfo(OrderSymbol(),MODE_POINT)-MarketInfo(Symbol(),MODE_SPREAD)*MarketInfo(Symbol(),MODE_POINT)))
            open_positions(Magic_Number, 5, Start_Lot, price_1-(Delta*k)*MarketInfo(OrderSymbol(),MODE_POINT)-MarketInfo(Symbol(),MODE_SPREAD)*MarketInfo(Symbol(),MODE_POINT), OrderSymbol(),Delta,Delta);
        }
      }
    }
   // Comment(MarketInfo(Symbol(),MODE_SPREAD));
  /*  if(OrderType()==4) {
      for(k=1; k<Count; k++) {
        if(!find_orders(4, Magic_Number, price_1+(Delta*k)*MarketInfo(OrderSymbol(),MODE_POINT)) && lot_1>Start_Lot)
          open_positions(Magic_Number, 4, Start_Lot, price_1+(Delta*k)*MarketInfo(OrderSymbol(),MODE_POINT), OrderSymbol(),Delta,TP);
      }
    }
    if(OrderType()==5) {
      for(k=1; k<Count; k++) {
        if(!find_orders(5, Magic_Number, price_1-(Delta*k)*MarketInfo(OrderSymbol(),MODE_POINT)) && lot_1>Start_Lot)
          open_positions(Magic_Number, 5, Start_Lot, price_1-(Delta*k)*MarketInfo(OrderSymbol(),MODE_POINT), OrderSymbol(),Delta,TP);
      }
    }*/
  }
 // Sleep(2000);
 
}

bool find_orders(int type=-1, int magic=-1, double price=-1) {
  int i = 0;

  for (i=OrdersTotal()-1; i>=0; i--) {
    if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;

    if(((OrderType()==type) || (type==-1))
       && ((OrderMagicNumber()==magic) || (magic==-1))
       && ((NormalizeDouble(OrderOpenPrice(),MarketInfo(OrderSymbol(),MODE_DIGITS))) 
           ==NormalizeDouble(price,MarketInfo(OrderSymbol(),MODE_DIGITS)) || (price==-1))) {
      return(true);
      break;
    }
  }
  return(false);  
}

//+-------------------------------------------------------------------------------------------------------------------+
//|                                                                                             |
void open_positions(int magic, int signal, double lot, double price=0.0, string symb="NONE", int sl=0, int tp=0) {
  //signal=1 ->    
  //signal=2 ->    
  /* extern */ int Count_Of_Trade_Try=5, Pause_Of_Trade_Try=5;
  /* extern */ int Slipage=5;
  /* extern */ //int SL, TP;
  /* extern  */ string Order_Comment="";
  /* extern */ int Magic_Number=magic;
  //Comment("mg: "+Magic_Number);
  int    i     = 0; //   
  int    count = Count_Of_Trade_Try; //     ,      

  if(symb=="NONE") symb=Symbol();
  if(signal==0)
    price=MarketInfo(symb,MODE_ASK); //   
  if(signal==1)
    price=MarketInfo(symb,MODE_BID); //   

  while(i<=count) {
    //    ().        :
    int ticket = OrderSend(Symbol(),      //
                           signal,      // 
                           lot,           //
                           price,         // 
                           Slipage,      //  
                           sl(sl,signal, symb, price), // Stop Loss
                           tp(tp,signal, symb, price), // Take Profit
                           Order_Comment, // 
                           magic,  // 
                           0,             //  (   )
                           CLR_NONE);     //     (CLR_NONE -   )
    if(ticket!=-1) { //   ,       
      break;
      if(Sound) PlaySound("alert.wav");
    }  
    if(GetLastError()!=0) Print(" ( ): "+Market_Err_To_Str(GetLastError()));
      i++;  
    Sleep(Pause_Of_Trade_Try*100); //       
  } //end while(i<=count)
} //end void open_positions(int signal)
//|                                                                                             |
//+-------------------------------------------------------------------------------------------------------------------+


//+-------------------------------------------------------------------------------------------------------+
//|                                                                          |
string Market_Err_To_Str(int err) {
/*        */
  switch(err) {
    case(0):   return(" ");
    case(1):   return(" ,   ");
    case(2):   return(" ");
    case(3):   return(" ");
    case(4):   return("  ");
    case(5):   return("   ");
    case(6):   return("    ");
    case(7):   return(" ");
    case(8):   return("  ");
    case(9):   return("    ");
    case(64):  return(" ");
    case(65):  return("  ");
    case(128): return("    ");
    case(129): return(" ");
    case(130): return(" ");
    case(131): return(" ");
    case(132): return(" ");
    case(133): return(" ");
    case(134): return("    ");
    case(135): return(" ");
    case(136): return(" ");
    case(137): return(" ");
    case(138): return(" ");
    case(139): return("    ");
    case(140): return("  ");
    case(141): return("  ");
    case(145): return(" , ..     ");
    case(146): return("  ");
    case(147): return("    ");
    case(148): return("      ,  ");
    case(149): return("        ,   ");
    case(150): return("         FIFO");
    
    default:return("");
  } //end switch(err)
} //end string Err_To_Str(int err)
//|                                                                          |
//+-------------------------------------------------------------------------------------------------------+

bool cbt(int type, int magic, int slipage) { 
  int n = 0;
  while (find_orders(type, magic))
    for (int i2=OrdersTotal()-1; i2>=0; i2--) {
      if (!OrderSelect(i2,SELECT_BY_POS,MODE_TRADES)) break;

      if(OrderType()==type && OrderMagicNumber()==magic) {
        close_by_ticket(OrderTicket(), slipage);
        n++;
      } 
    }

  if(n>0)    
    return(true);

  return(false);
}

//+-------------------------------------------------------------------------------------------------------------------+
//|                                        ()                                    |


bool close_by_ticket(int c_ticket, int slipage) {
  /*
           ().
              (slipage)
  */
/* extern */ int Count_Of_Trade_Try=5, Pause_Of_Trade_Try=5;

int   i        = 0;     //   
bool  ticket   = false; //   ()   
double price   = 0.0; //    (  )
  if(OrderSelect(c_ticket,SELECT_BY_TICKET,MODE_TRADES)) { //   
    if(OrderType()==OP_BUY)  price = Bid; //  
    if(OrderType()==OP_SELL) price = Ask; //  
    for(i=0;i<=Count_Of_Trade_Try;i++) {
      if(OrderType()<=1) //   -  ,   - 
        ticket=OrderClose(OrderTicket(),OrderLots(),price,slipage,CLR_NONE);
      else
        ticket=OrderDelete(OrderTicket());

      if(ticket) { //      -  true    
        return(true);
        break;
      } //end if(ticket)
      if(GetLastError()!=0) Print(": "+Market_Err_To_Str(GetLastError()));
      Sleep(Pause_Of_Trade_Try*100); //       
    } //end for(i=0;i<=Count_Of_Trade_Try;i++)
  } //end if(OrderSelect(c_ticket,SELECT_BY_TICKET,MODE_TRADES))

  return(false); // false
  

} //end bool close_by_ticket(int c_ticket)
//|                                        ()                                    |
//+-------------------------------------------------------------------------------------------------------------------+
/*
int c_by_type(int type, int magic, double lot) {
  int i = 0;
  int c = 1;
  for (i=OrdersTotal()-1; i>=0; i--) {
    if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;

    if((OrderType()==type) && (OrderMagicNumber()==Magic_Number)
       && (OrderLots()==lot))
      c++;
  }
  return(c);
}*/ 

int last_time() {
  int    i      = 0;
  int    time   = -1;
  for(i=OrdersHistoryTotal()-1; i>=0; i--) {
    if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) break;
    if((OrderType()==0) || (OrderType()==1)) {
      if((OrderMagicNumber()==Magic_Number)
         && (OrderType()<=1)) {
        if(OrderCloseTime()>time) 
          time   = OrderCloseTime();
      } //end if(OrderCloseTime()>time)
    } //end if((OrderType()==0) || (OrderType()==1))
  } //end for (i=OrdersHistoryTotal()-1; i>=0; i--)
  return(time);
}

int start()
  {
//----
  RefreshRates();
 if(
    (last_time()!=-1)
     && (
         (!GlobalVariableCheck("last_open"+Symbol()+Period()))
          || (GlobalVariableGet("last_open"+Symbol()+Period())<last_time())
        )
    ) {
     //Comment(c_by_type(4, Magic_Number, Start_Lot)," ",c_by_type(5, Magic_Number, Start_Lot));
    cbt(4, Magic_Number, 0);
   //  Sleep(200);
    cbt(5, Magic_Number, 0);
    GlobalVariableSet("last_open"+Symbol()+Period(),last_time());
   //  Sleep(200);
   }
   if(!find_orders(-1, Magic_Number)) {

     open_positions(Magic_Number, Test_First_Order, Start_Lot,0.0,Symbol(), Delta, Delta);
     //GlobalVariableSet("last_open"+Symbol()+Period());
   }  
   

   check_orders();

   return(0);
  }
//+------------------------------------------------------------------+